## ros-indigo-sr-hand 1.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(sr_hand)

find_package(catkin REQUIRED COMPONENTS rostest roslib roscpp rospy std_msgs std_srvs sensor_msgs sr_robot_msgs control_msgs controller_manager_msgs
  sr_utilities diagnostic_msgs dynamic_reconfigure self_test urdf gazebo_msgs)
find_package(gazebo REQUIRED)
include_directories(include ${Boost_INCLUDE_DIR} ${catkin_INCLUDE_DIRS} ${GAZEBO_INCLUDE_DIRS} ${SDFormat_INCLUDE_DIRS})

catkin_python_setup()

catkin_package(
    DEPENDS gazebo
    CATKIN_DEPENDS roslib roscpp rospy std_msgs std_srvs sensor_msgs sr_robot_msgs control_msgs controller_manager_msgs sr_utilities
      diagnostic_msgs dynamic_reconfigure self_test urdf gazebo_msgs
    INCLUDE_DIRS include
    LIBRARIES HandCommander SrVirtual
)

###################
#  CONFIGURATION  #
###################

# Real Hand
set(real_hand $ENV{REAL_HAND})
if(real_hand)
  message(" [x] Real Hand.")
else(real_hand)
  message(" [ ] Real Hand.")
endif(real_hand)

#Real Arm
set(real_arm $ENV{REAL_ARM})
if(real_arm)
  message(" [x] Real Arm.")
else(real_arm)
  message(" [ ] Real Arm.")
endif(real_arm)

#Valves
set(muscle $ENV{MUSCLE})
if(real_hand)
  if(muscle)
    message(" [x] Valves.")
  else(muscle)
    message(" [ ] Valves.")
  endif(muscle)
else(real_hand)
  message(" [ ] Valves.")
endif(real_hand)
message("---------")

#CAN compatibility Interface
set(can_compat $ENV{CAN_COMPATIBILITY})
if(can_compat)
  message(" [x] CAN compatibility interface.")
else(can_compat)
  message(" [ ] CAN compatibility interface.")
endif(can_compat)

##################
#  VIRTUAL ARM  #
##################

add_executable(shadowarm_virtual src/hand/sr_articulated_robot.cpp src/hand/virtual_arm.cpp src/sr_publisher.cpp src/sr_subscriber.cpp
  src/hand/virtual_arm_node.cpp src/sr_diagnosticer.cpp)
add_dependencies(shadowarm_virtual ${catkin_EXPORTED_TARGETS})
find_package(Boost REQUIRED COMPONENTS thread)
include_directories(${Boost_INCLUDE_DIRS})
target_link_libraries(shadowarm_virtual ${Boost_LIBRARIES} ${catkin_LIBRARIES})


##################
#  VIRTUAL HAND  #
##################
add_executable(shadowhand_virtual src/hand/sr_articulated_robot.cpp src/hand/virtual_shadowhand.cpp src/sr_publisher.cpp src/sr_subscriber.cpp
  src/hand/virtual_shadowhand_node.cpp src/sr_diagnosticer.cpp)
add_dependencies(shadowhand_virtual ${catkin_EXPORTED_TARGETS})
target_link_libraries(shadowhand_virtual ${Boost_LIBRARIES} ${catkin_LIBRARIES})


###########################
#  VIRTUAL HAND  LIBRARY  #
###########################

add_library(SrVirtual src/hand/sr_articulated_robot.cpp src/hand/virtual_shadowhand_library.cpp)
add_dependencies(SrVirtual ${catkin_EXPORTED_TARGETS})
target_link_libraries(SrVirtual ${Boost_LIBRARIES} ${catkin_LIBRARIES})

##################
#    REAL HAND   #
##################
if(real_hand)
  include_directories(/usr/realtime/include/)
  add_library(robot STATIC IMPORTED)
  add_dependencies(robot ${catkin_EXPORTED_TARGETS})
  set_property(TARGET robot PROPERTY IMPORTED_LOCATION /usr/lib/robot.a)
  add_executable(shadowhand_real src/hand/sr_articulated_robot.cpp src/hand/real_shadowhand.cpp src/sr_publisher.cpp src/sr_subscriber.cpp
    src/hand/real_shadowhand_node.cpp src/sr_diagnosticer.cpp)
  add_dependencies(shadowhand_real ${catkin_EXPORTED_TARGETS})
  target_link_libraries(shadowhand_real ${Boost_LIBRARIES} ${catkin_LIBRARIES} pthread robot)
endif(real_hand)

#########################################
#  ETHERCAT COMPATIBILITY WRAPPER HAND  #
#########################################
add_executable(shadowhand_ethercat src/hand/sr_articulated_robot.cpp src/hand/etherCAT_compatibility_hand.cpp src/sr_publisher.cpp
  src/sr_subscriber.cpp src/hand/etherCAT_compatibility_hand_node.cpp src/sr_diagnosticer.cpp)
add_dependencies(shadowhand_ethercat ${catkin_EXPORTED_TARGETS})
target_link_libraries(shadowhand_ethercat ${Boost_LIBRARIES} ${catkin_LIBRARIES})
message(" [x] EtherCAT compatibility interface.")

###################################
#  CAN COMPATIBILITY WRAPPER ARM  #
###################################
if(can_compat)
  add_executable(shadowarm_can src/hand/sr_articulated_robot.cpp src/hand/CAN_compatibility_arm.cpp src/sr_publisher.cpp
    src/sr_subscriber.cpp src/hand/CAN_compatibility_arm_node.cpp)
  add_dependencies(shadowarm_can ${catkin_EXPORTED_TARGETS})
  target_link_libraries(shadowarm_can ${Boost_LIBRARIES} ${catkin_LIBRARIES})
endif(can_compat)

##################
#    REAL ARM    #
##################
if(real_arm)
  include_directories(/usr/realtime/include/)
  add_executable(shadowarm_real src/hand/sr_articulated_robot.cpp src/hand/real_arm.cpp src/sr_publisher.cpp src/sr_subscriber.cpp
    src/hand/real_arm_node.cpp src/sr_diagnosticer.cpp)
  add_dependencies(shadowarm_real ${catkin_EXPORTED_TARGETS})
  target_link_libraries(shadowarm_real ${Boost_LIBRARIES} ${catkin_LIBRARIES} pthread robot)
endif(real_arm)

##################
#     VALVES     #
##################
if(valves)
  include_directories(/usr/realtime/include/)
  add_executable(sr_valves src/hand/valves.cpp src/hand/valves_node.cpp)
  add_dependencies(sr_valves ${catkin_EXPORTED_TARGETS})
  target_link_libraries(sr_valves ${Boost_LIBRARIES} ${catkin_LIBRARIES} pthread robot)
endif(valves)

############################################################################
#   Hand command library (gives compatibility with CAN and ethercat hand)  #
############################################################################
add_definitions(-fPIC)
add_library(HandCommander src/hand_commander.cpp)
add_dependencies(HandCommander ${catkin_EXPORTED_TARGETS})
target_link_libraries(HandCommander ${Boost_LIBRARIES} ${catkin_LIBRARIES})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")


if(COMMAND add_rostest_gtest)
  add_rostest_gtest(hand_commander_test test/hand_commander_test.test test/hand_commander_test.cpp)
  add_dependencies(hand_commander_test ${catkin_EXPORTED_TARGETS})
  target_link_libraries(hand_commander_test HandCommander ${GTEST_LIBRARIES} ${catkin_LIBRARIES})
  add_rostest(test/hand_commander_mock_test.test)
  add_rostest_gtest(hand_commander_arm_and_hand_test test/hand_commander_arm_and_hand_test.test test/hand_commander_test.cpp)
  add_dependencies(hand_commander_arm_and_hand_test ${catkin_EXPORTED_TARGETS})
  target_link_libraries(hand_commander_arm_and_hand_test HandCommander ${GTEST_LIBRARIES} ${catkin_LIBRARIES})
endif(COMMAND add_rostest_gtest)

if(valves)
  install(TARGETS shadowhand_virtual shadowarm_virtual SrVirtual shadowhand_ethercat HandCommander sr_valves
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )
else(valves)
  install(TARGETS shadowhand_virtual shadowarm_virtual SrVirtual shadowhand_ethercat HandCommander
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )
endif()

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(DIRECTORY examples/
   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/examples)

install(DIRECTORY launch/
   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch)

install(FILES scripts/sr_hand/grasps.xml DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/scripts/sr_hand)

=== debian/changelog ===
ros-indigo-sr-hand (1.4.0-0trusty) trusty; urgency=high

  * starting trajectory controllers only for the arm when running arm + hand as it is more standard. Can't have both running with ros_control
  * removing cartesian control - not implemented in ros-control + changing to the new traj controller
  * Added shutdown-timeout=1.0 in controller spawner to improve shutdown time
    Added a boolean to stop spinner in gazebo controller manager plugin to improve shutdown
  * Better ethercat compatibility
  * Add arguments to allow launching a particular robot model on gazebo.
  * Moved gnuplot as a run dependency since sr_self_test is also running outside the gtest
    Fixed missing image_path
  * mod debug mode of launch file
    added args for launching gazebo
    renamed joint variable in python because it shadowed import
  * deleting deprecated rviz config
  * adding the standard ros topics to our old hand interface - useulf for the virtual hand

 -- Shadow Robot's software team <software@shadowrobot.com>  Mon, 06 Apr 2015 23:00:00 -0000

ros-indigo-sr-hand (1.3.1-0trusty) trusty; urgency=high



 -- Shadow Robot's software team <software@shadowrobot.com>  Thu, 17 Jul 2014 23:00:00 -0000

ros-indigo-sr-hand (1.3.0-0trusty) trusty; urgency=high

  * first hydro release

 -- Shadow Robot's software team <software@shadowrobot.com>  Tue, 11 Feb 2014 00:00:00 -0000

=== debian/control ===
Source: ros-indigo-sr-hand
Section: misc
Priority: extra
Maintainer: Shadow Robot's software team <software@shadowrobot.com>
Build-Depends: debhelper (>= 9.0.0), gazebo2, libgtest-dev, ros-indigo-catkin, ros-indigo-control-msgs, ros-indigo-controller-manager-msgs, ros-indigo-diagnostic-msgs, ros-indigo-dynamic-reconfigure, ros-indigo-gazebo-msgs, ros-indigo-roscpp, ros-indigo-roslib, ros-indigo-rospy, ros-indigo-rostest, ros-indigo-self-test, ros-indigo-sensor-msgs, ros-indigo-sr-robot-msgs, ros-indigo-sr-utilities, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-urdf
Homepage: http://www.shadowrobot.com
Standards-Version: 3.9.2

Package: ros-indigo-sr-hand
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gazebo2, ros-indigo-control-msgs, ros-indigo-controller-manager-msgs, ros-indigo-diagnostic-msgs, ros-indigo-dynamic-reconfigure, ros-indigo-gazebo-msgs, ros-indigo-gazebo-ros, ros-indigo-robot-state-publisher, ros-indigo-roscpp, ros-indigo-roslib, ros-indigo-rospy, ros-indigo-self-test, ros-indigo-sensor-msgs, ros-indigo-sr-robot-msgs, ros-indigo-sr-utilities, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-urdf
Description: This is a ROS interface to the Shadow Robot's robotic hand. It contains both an interface to the real hand (communicating via a CAN interface) and a simulated version of the hand. It also contains an interface to Shadow Robot's muscle arm.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-sr-hand//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
